// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/karmada-io/karmada/pkg/apis/config/v1alpha1"
	scheme "github.com/karmada-io/karmada/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ResourceInterpreterCustomizationsGetter has a method to return a ResourceInterpreterCustomizationInterface.
// A group's client should implement this interface.
type ResourceInterpreterCustomizationsGetter interface {
	ResourceInterpreterCustomizations() ResourceInterpreterCustomizationInterface
}

// ResourceInterpreterCustomizationInterface has methods to work with ResourceInterpreterCustomization resources.
type ResourceInterpreterCustomizationInterface interface {
	Create(ctx context.Context, resourceInterpreterCustomization *v1alpha1.ResourceInterpreterCustomization, opts v1.CreateOptions) (*v1alpha1.ResourceInterpreterCustomization, error)
	Update(ctx context.Context, resourceInterpreterCustomization *v1alpha1.ResourceInterpreterCustomization, opts v1.UpdateOptions) (*v1alpha1.ResourceInterpreterCustomization, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.ResourceInterpreterCustomization, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.ResourceInterpreterCustomizationList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ResourceInterpreterCustomization, err error)
	ResourceInterpreterCustomizationExpansion
}

// resourceInterpreterCustomizations implements ResourceInterpreterCustomizationInterface
type resourceInterpreterCustomizations struct {
	client rest.Interface
}

// newResourceInterpreterCustomizations returns a ResourceInterpreterCustomizations
func newResourceInterpreterCustomizations(c *ConfigV1alpha1Client) *resourceInterpreterCustomizations {
	return &resourceInterpreterCustomizations{
		client: c.RESTClient(),
	}
}

// Get takes name of the resourceInterpreterCustomization, and returns the corresponding resourceInterpreterCustomization object, and an error if there is any.
func (c *resourceInterpreterCustomizations) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ResourceInterpreterCustomization, err error) {
	result = &v1alpha1.ResourceInterpreterCustomization{}
	err = c.client.Get().
		Resource("resourceinterpretercustomizations").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ResourceInterpreterCustomizations that match those selectors.
func (c *resourceInterpreterCustomizations) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ResourceInterpreterCustomizationList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.ResourceInterpreterCustomizationList{}
	err = c.client.Get().
		Resource("resourceinterpretercustomizations").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested resourceInterpreterCustomizations.
func (c *resourceInterpreterCustomizations) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("resourceinterpretercustomizations").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a resourceInterpreterCustomization and creates it.  Returns the server's representation of the resourceInterpreterCustomization, and an error, if there is any.
func (c *resourceInterpreterCustomizations) Create(ctx context.Context, resourceInterpreterCustomization *v1alpha1.ResourceInterpreterCustomization, opts v1.CreateOptions) (result *v1alpha1.ResourceInterpreterCustomization, err error) {
	result = &v1alpha1.ResourceInterpreterCustomization{}
	err = c.client.Post().
		Resource("resourceinterpretercustomizations").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(resourceInterpreterCustomization).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a resourceInterpreterCustomization and updates it. Returns the server's representation of the resourceInterpreterCustomization, and an error, if there is any.
func (c *resourceInterpreterCustomizations) Update(ctx context.Context, resourceInterpreterCustomization *v1alpha1.ResourceInterpreterCustomization, opts v1.UpdateOptions) (result *v1alpha1.ResourceInterpreterCustomization, err error) {
	result = &v1alpha1.ResourceInterpreterCustomization{}
	err = c.client.Put().
		Resource("resourceinterpretercustomizations").
		Name(resourceInterpreterCustomization.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(resourceInterpreterCustomization).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the resourceInterpreterCustomization and deletes it. Returns an error if one occurs.
func (c *resourceInterpreterCustomizations) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("resourceinterpretercustomizations").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *resourceInterpreterCustomizations) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("resourceinterpretercustomizations").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched resourceInterpreterCustomization.
func (c *resourceInterpreterCustomizations) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ResourceInterpreterCustomization, err error) {
	result = &v1alpha1.ResourceInterpreterCustomization{}
	err = c.client.Patch(pt).
		Resource("resourceinterpretercustomizations").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
