// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/karmada-io/karmada/pkg/apis/work/v1alpha1"
	scheme "github.com/karmada-io/karmada/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ResourceBindingsGetter has a method to return a ResourceBindingInterface.
// A group's client should implement this interface.
type ResourceBindingsGetter interface {
	ResourceBindings(namespace string) ResourceBindingInterface
}

// ResourceBindingInterface has methods to work with ResourceBinding resources.
type ResourceBindingInterface interface {
	Create(ctx context.Context, resourceBinding *v1alpha1.ResourceBinding, opts v1.CreateOptions) (*v1alpha1.ResourceBinding, error)
	Update(ctx context.Context, resourceBinding *v1alpha1.ResourceBinding, opts v1.UpdateOptions) (*v1alpha1.ResourceBinding, error)
	UpdateStatus(ctx context.Context, resourceBinding *v1alpha1.ResourceBinding, opts v1.UpdateOptions) (*v1alpha1.ResourceBinding, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.ResourceBinding, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.ResourceBindingList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ResourceBinding, err error)
	ResourceBindingExpansion
}

// resourceBindings implements ResourceBindingInterface
type resourceBindings struct {
	client rest.Interface
	ns     string
}

// newResourceBindings returns a ResourceBindings
func newResourceBindings(c *WorkV1alpha1Client, namespace string) *resourceBindings {
	return &resourceBindings{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the resourceBinding, and returns the corresponding resourceBinding object, and an error if there is any.
func (c *resourceBindings) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ResourceBinding, err error) {
	result = &v1alpha1.ResourceBinding{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("resourcebindings").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ResourceBindings that match those selectors.
func (c *resourceBindings) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ResourceBindingList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.ResourceBindingList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("resourcebindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested resourceBindings.
func (c *resourceBindings) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("resourcebindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a resourceBinding and creates it.  Returns the server's representation of the resourceBinding, and an error, if there is any.
func (c *resourceBindings) Create(ctx context.Context, resourceBinding *v1alpha1.ResourceBinding, opts v1.CreateOptions) (result *v1alpha1.ResourceBinding, err error) {
	result = &v1alpha1.ResourceBinding{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("resourcebindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(resourceBinding).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a resourceBinding and updates it. Returns the server's representation of the resourceBinding, and an error, if there is any.
func (c *resourceBindings) Update(ctx context.Context, resourceBinding *v1alpha1.ResourceBinding, opts v1.UpdateOptions) (result *v1alpha1.ResourceBinding, err error) {
	result = &v1alpha1.ResourceBinding{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("resourcebindings").
		Name(resourceBinding.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(resourceBinding).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *resourceBindings) UpdateStatus(ctx context.Context, resourceBinding *v1alpha1.ResourceBinding, opts v1.UpdateOptions) (result *v1alpha1.ResourceBinding, err error) {
	result = &v1alpha1.ResourceBinding{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("resourcebindings").
		Name(resourceBinding.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(resourceBinding).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the resourceBinding and deletes it. Returns an error if one occurs.
func (c *resourceBindings) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("resourcebindings").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *resourceBindings) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("resourcebindings").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched resourceBinding.
func (c *resourceBindings) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ResourceBinding, err error) {
	result = &v1alpha1.ResourceBinding{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("resourcebindings").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
