// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/karmada-io/karmada/pkg/apis/work/v1alpha1"
	scheme "github.com/karmada-io/karmada/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// WorksGetter has a method to return a WorkInterface.
// A group's client should implement this interface.
type WorksGetter interface {
	Works(namespace string) WorkInterface
}

// WorkInterface has methods to work with Work resources.
type WorkInterface interface {
	Create(ctx context.Context, work *v1alpha1.Work, opts v1.CreateOptions) (*v1alpha1.Work, error)
	Update(ctx context.Context, work *v1alpha1.Work, opts v1.UpdateOptions) (*v1alpha1.Work, error)
	UpdateStatus(ctx context.Context, work *v1alpha1.Work, opts v1.UpdateOptions) (*v1alpha1.Work, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.Work, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.WorkList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Work, err error)
	WorkExpansion
}

// works implements WorkInterface
type works struct {
	client rest.Interface
	ns     string
}

// newWorks returns a Works
func newWorks(c *WorkV1alpha1Client, namespace string) *works {
	return &works{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the work, and returns the corresponding work object, and an error if there is any.
func (c *works) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.Work, err error) {
	result = &v1alpha1.Work{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("works").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of Works that match those selectors.
func (c *works) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.WorkList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.WorkList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("works").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested works.
func (c *works) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("works").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a work and creates it.  Returns the server's representation of the work, and an error, if there is any.
func (c *works) Create(ctx context.Context, work *v1alpha1.Work, opts v1.CreateOptions) (result *v1alpha1.Work, err error) {
	result = &v1alpha1.Work{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("works").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(work).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a work and updates it. Returns the server's representation of the work, and an error, if there is any.
func (c *works) Update(ctx context.Context, work *v1alpha1.Work, opts v1.UpdateOptions) (result *v1alpha1.Work, err error) {
	result = &v1alpha1.Work{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("works").
		Name(work.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(work).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *works) UpdateStatus(ctx context.Context, work *v1alpha1.Work, opts v1.UpdateOptions) (result *v1alpha1.Work, err error) {
	result = &v1alpha1.Work{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("works").
		Name(work.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(work).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the work and deletes it. Returns an error if one occurs.
func (c *works) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("works").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *works) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("works").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched work.
func (c *works) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Work, err error) {
	result = &v1alpha1.Work{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("works").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
